//Projet Eclipse ClignoteLed
//
import com.pi4j.io.gpio.GpioController;
import com.pi4j.io.gpio.GpioFactory;
import com.pi4j.io.gpio.GpioPinDigitalOutput;
import com.pi4j.io.gpio.PinState;
import com.pi4j.io.gpio.RaspiPin;

public class ClignoteLedAmel {
	private boolean  isTarget   =  true;  //Raspberry Pi
	private GpioController gpio;
	private GpioPinDigitalOutput ledPin;
	
  ClignoteLedAmel(boolean isTarget) {
  	this.isTarget = isTarget;
  	
  	if (isTarget) {
  		//Creation du gpio controller
			//
			gpio = GpioFactory.getInstance();
			ledPin = gpio.provisionDigitalOutputPin(RaspiPin.GPIO_01);
  	}
  }
  
  public void clignoteLed() {
  	try {
			if (isTarget) { //Sur le Rasperry Pi
				//Clignote toutes les 2 secondes pendant 10 secondes
				//
				ledPin.blink(2000, 10000);
				
				Runtime.getRuntime().addShutdownHook(new Thread() {
					public void run() {
						System.out.println("Ctrl+C !!");
						ledPin.setState(PinState.LOW);
					}
				});
			}
			
			//Boucle infinie, Ctrl-C nécessaire
      while (true) {
      	Thread.sleep(500);
      }
		} 
		catch (Exception e) {
			e.printStackTrace();
		}
  }
	
	public static void main(String[] args) {
		boolean isRaspb = true;
		if (System.getProperty("os.name").startsWith("Windows")) {
			isRaspb = false;
		}
		
		ClignoteLedAmel cLA = new ClignoteLedAmel(isRaspb);
		cLA.clignoteLed();
	}
}