//Projet Eclipse ConfigParam
//
import java.io.BufferedReader;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;

public class ConfigParam1 {	
	private String paramFile = null;
	 	
	public ConfigParam1(String paramFile) {
		this.paramFile = paramFile;
	}
	
	/**
	 * Lecture des paramètres du fichier de configuration
	 * 
	 * @return true (ok) ou false pour différents cas d'erreur
	 */
	public boolean readConfig() {
		BufferedReader br = null;
		try {
			br = new BufferedReader(new FileReader(paramFile));
		} 
		catch (FileNotFoundException e) {
			System.out.println("Le fichier " + paramFile + " n'existe pas");
			System.exit(-1);
		}
		
		String oneLine = null;
		for (;;) {
			try {
				oneLine = br.readLine();
			} 
			catch (IOException e) {
				break;
			}
			
			if (oneLine == null) {  //fin du fichier
				break;
			}
			
			//Nous éliminons tabulations et espaces 
			//
			oneLine = oneLine.replace("\t"," ");
			oneLine = oneLine.replace(" ","");
			
			//Le signe = sépare paramètre et valeur
      //Le ; signale un commentaire
			//
			int indexSep = oneLine.indexOf('=');  
			int indexSemiCol = oneLine.indexOf(';');
			
			if (indexSemiCol == -1) {  //Définition sans commentaire
				indexSemiCol = oneLine.length();
			}
			
			if ((indexSep > 0) && (indexSemiCol > 0)) {
				String key   = oneLine.substring(0, indexSep);
				String value = oneLine.substring(indexSep + 1, indexSemiCol);
				
				if (value.length() != 0) {				
					System.out.println("Paramètre: " + key + "  Valeur: " + value);
				}
			}
		}
		
		try {
			br.close();
		} 
		catch (IOException e) {
			return false;
		}
		
		return true;
	}	
	
	public static void main(String[] args) {
		ConfigParam1 ourParams = new ConfigParam1("config.txt");
		ourParams.readConfig();
	}
}