//Projet Eclipse ProcessBuilderPython
//
import java.io.BufferedReader;
import java.io.File;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;

public class ProcessBuilderPython {
	private String pythonCmd = "";
	
	private String result    = "";
	private String errorMsg  = "";
	private String errorMsg2 = "";

	public ProcessBuilderPython(String pythonCmd) {
		this.pythonCmd = pythonCmd;
	}
	
	public String getResult() {
		return result;  //Le résultat du script
	}
	
	public String getErrorMsg() {
		return errorMsg;  //Message d'erreur
	}
	
	public String getErrorMsg2() {
		return errorMsg2;  //Message d'exception
	}
	
	
	public boolean executeScript(String[] pythonScriptParams) {
		String prBuilCmd[] = new String[1 + pythonScriptParams.length];
		
		prBuilCmd[0] = pythonCmd;
		for (int i = 0; i < pythonScriptParams.length; i++) {
			prBuilCmd[1 + i] = pythonScriptParams[i];
		}
		
		File pythonScript = new File(prBuilCmd[1]);
		if (!pythonScript.exists()) {
			errorMsg = prBuilCmd[1] + " n'existe pas";
			return false;
		}
		
		ProcessBuilder prBuild = new ProcessBuilder(prBuilCmd);

    Process process = null;
    try {
			process = prBuild.start();
			
			if (process.waitFor() == 0) {
				result = pyOutput(process.getInputStream());
			}
			else {
				errorMsg = pythonScriptParams[0] + " exécuté avec erreur";
				return false;
			} 
		} 
    catch(IOException e) {
    	errorMsg  = "Erreur IO";
			errorMsg2 = e.getMessage();
			return false;
		} 
    catch(InterruptedException e) {
    	errorMsg = "Erreur process";
    	errorMsg2 = e.getMessage();
    	return false;
		}   
		
		return true;
	}
	
	public String pyOutput(InputStream inputStream) throws IOException {
    StringBuilder  sb = new StringBuilder();
    BufferedReader br = new BufferedReader(new InputStreamReader(inputStream));
    
    String line = null;
    while ((line = br.readLine()) != null) {
      sb.append(line + System.getProperty("line.separator"));
    }
  
    return sb.toString();
  }
	
	public static void main(String[] args) {
		//Test de la classe ProcessBuilderPython
		//
		ProcessBuilderPython pBP = new ProcessBuilderPython("python");
		
		String[] pythonScript = {
				"blinkleds.py",
				"3"
		};
		
		boolean res = pBP.executeScript(pythonScript);
		if (res == true) {
			System.out.println("blinkleds.py exécuté correctement");
			System.out.println("Résultat: " + pBP.getResult());
		}
		else {
			System.out.println("Msg:  " + pBP.getErrorMsg());
			System.out.println("Msg2: " + pBP.getErrorMsg2());
		}
	}
}
