//Projet Eclipse ProcessBuilderPython
//
public class TwoPythonScripts {
	static String pythonCmd = "python";	 
  
	static String result1 = null;
	static String result2 = null;
	
	public static void pause(int ms) {
  	try {
			Thread.sleep(ms);
		} 
		catch (InterruptedException e) {
			e.printStackTrace();
		}
  }
	
	public static void main(String[] args) {	
		if (System.getProperty("os.name").startsWith("Windows")) {
			pythonCmd = "D:/Python/Python36-32/python.exe";
		}
		
		Thread script1Thread = new Thread() {  //Script blinkleds.py
			public void run() {				
				ProcessBuilderPython pBP = new ProcessBuilderPython(pythonCmd);			
				String[] pythonScript = {
						"blinkleds.py",
						"6"
				};
				
				boolean res = pBP.executeScript(pythonScript);
				if (res != true) {
					result1 = pBP.getErrorMsg();
				}
				else {
					result1 = pBP.getResult();
				}
		  }
		};
		
		Thread script2Thread = new Thread() {  //Script salut.py
			public void run() {				
				ProcessBuilderPython pBP = new ProcessBuilderPython(pythonCmd);			
				String[] pythonScript = {
						"salut.py",
						"Michel"
				};
				
				boolean res = pBP.executeScript(pythonScript);
				if (res != true) {
					result2 = pBP.getErrorMsg();
				}
				else {
					result2 = pBP.getResult();
				}
		  }
		};
		
		script1Thread.start(); //Démarre premier script Python
		script2Thread.start(); //Démarre second script Python
		
		boolean msgDone = false;
		while ((result1 == null) || (result2 == null)) {
			pause(100);  //Ou autre chose
			
			if (result1 != null) {
				if (!msgDone) {
					msgDone = true;
					System.out.println("Thread1 terminé");
				}
			}
			
			if (result2 != null) {
				if (!msgDone) {
					msgDone = true;
					System.out.println("Thread2 terminé");
				}				
			}
		}
		
		System.out.println("Res1: " + result1);
		System.out.println("Res2: " + result2);
	}
}