//Projet Eclipse RelaisEclairage
//
import com.pi4j.io.gpio.RaspiPin;

public class PresenceSimulation {
	public static void pause(int ms) {
  	try {
			Thread.sleep(ms);
		} 
		catch (InterruptedException e) {
			e.printStackTrace();
		}
  }

	public static void main(String[] args) {
		String beforeSunrise = "05:31";	//Matin: rien avant
		String afterSunset   = "22:26";	//Soir: plus rien après
		int delaySunrise     = 600;     //Secs. 10 heures après le lever !!!
		int delaySunset      = 5;       //Secs. 5 minutes avant le coucher		
		
		boolean isTarget = true;  //Le Raspberry Pi
		if (System.getProperty("os.name").startsWith("Windows")) {
			isTarget = false;
		}  
		
		double latitude = 46.8167 ;  //Une latitude en Europe 
	  double shifting = 0.48;      //Correction en longitude
		MorningEveningPeriods mep = new MorningEveningPeriods(latitude, shifting, beforeSunrise, afterSunset, delaySunrise, delaySunset);
		mep.computePeriods();
    
		boolean withPrint1 = true;
		boolean withPrint2 = false;
		int     pauseSecs  = 2000;
		
		int periodOn  = 12; //Secs
		int periodOff = 8;  //Secs
		int variation = 5;  //Entre 0 et 4 secs
		
		
		Relay ourRelay = new Relay(isTarget, RaspiPin.GPIO_04, periodOn, periodOff, withPrint2);	
		ourRelay.setRndValue(variation);
		
		for (;;) {
			if (mep.isMorningEvening()) {
				if (withPrint1) {
					System.out.println("Nous sommes dans une des deux");
				}
				
				ourRelay.relayOnOff();  //Alterne ON et OFF
				if (withPrint1) {
					System.out.println("Status du relais: " + ourRelay.getRelayStatus());
				}
			}
			else {
				//Si sommes sorti d'une période active
				//
				if (ourRelay.getRelayStatus()) {
					ourRelay.activateOurRelay(false);
				}
			}
			
			pause(pauseSecs);
		}
	}
}
