//Projet Eclipse RelaisEclairage
//
import com.pi4j.io.gpio.GpioController;
import com.pi4j.io.gpio.GpioFactory;
import com.pi4j.io.gpio.GpioPinPwmOutput;
import com.pi4j.io.gpio.Pin;
import com.pi4j.io.gpio.RaspiPin;
import com.pi4j.util.CommandArgumentParser;

public class AlarmBuzzer {
	public static void main(String[] args) throws InterruptedException {
		if (System.getProperty("os.name").startsWith("Windows")) {
			System.out.println("Nous sommes sous Windows");
			return;
		}

		// Instance du controlleur GPIO
		//
		GpioController gpio = GpioFactory.getInstance();

		// Dans cet exemple, nous utiliserons la broche 32, c'est-à-dire le GPIO_26
		//
		Pin pin = CommandArgumentParser.getPin(RaspiPin.class, // Pour obtenir l'instance de Pin
		    RaspiPin.GPIO_26, // Notre broche fixée
		    args); // Argument de main() non utilisé

		GpioPinPwmOutput pwm = gpio.provisionPwmOutputPin(pin);

		// Modes du Buzzer pour notre exercice
		//
		com.pi4j.wiringpi.Gpio.pwmSetMode(com.pi4j.wiringpi.Gpio.PWM_MODE_MS);
		com.pi4j.wiringpi.Gpio.pwmSetRange(1000);
		com.pi4j.wiringpi.Gpio.pwmSetClock(100);

		// Taux PWM à 500 pour 0.8 seconde
		pwm.setPwm(500);
		Thread.sleep(800);

		// Pause de 1 seconde
		pwm.setPwm(0);
		Thread.sleep(500);

		// Fréquence 10 fois plus élevée
		com.pi4j.wiringpi.Gpio.pwmSetClock(500);

		//// Taux PWM à 500 pour 1.2 secondes
		pwm.setPwm(500);
		Thread.sleep(1200);

		// Pause de 1 seconde
		pwm.setPwm(0);
		Thread.sleep(500);

		// Fréquence plus basse
		com.pi4j.wiringpi.Gpio.pwmSetClock(50);

		//// Taux PWM à 100 pour 2 beeps
		pwm.setPwm(100);
		Thread.sleep(200);
		pwm.setPwm(0);
		Thread.sleep(100);
		pwm.setPwm(100);
		Thread.sleep(200);

		pwm.setPwm(0); // Stop le buzzer définitivement

		// Stop toutes les activités du contrôleur GPIO
		//
		gpio.shutdown();
	}
}