//Projet Eclipse DS18B20
//
import java.io.BufferedReader;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;

public class DS18x20read {
	
	private String fileName = "w1_slave";
	
	public DS18x20read(String fileName) {
		this.fileName = fileName;
	}
	
	public float getValue() {   //Obtient la valeur de température
		float t1Float = 999;
		
		BufferedReader br = null;
		try {
			br = new BufferedReader(new FileReader(fileName));
			
			String line = null;
			try {
				line = br.readLine();	//Ignore la première ligne
					
				line = br.readLine();
				if (line == null) {
					t1Float = 998;  // Aucune ligne de température à lire
				}
				else {
					int position = line.indexOf("t=");  //Index de position
					int t1Dec = 997;
					if (position > 0) {
						//Le String entier qui vient après le t=
						//
						String t1Val  = line.substring(position + 2);
						try {
							t1Dec     = Integer.parseInt(t1Val)/100;  //Conversion en int
							t1Float = ((float)t1Dec)/10;
						}
						catch(NumberFormatException nfe) {
							br.close();
							return t1Float;
						}
						
						t1Float = ((float)t1Dec)/10;
						br.close();
					}			
				}
			} 
			catch (IOException e) {
				return 995;
			}  
			
		}
		catch (FileNotFoundException e) {
			t1Float = 994;
		}
		
		return t1Float;
	}
	
	public static void main(String[] args) {
		String fileName = "w1_slave";	
		if (args.length > 0) {
			fileName = args[0];
	  }
		
		DS18x20read tempeRature = new DS18x20read(fileName);

		System.out.println("Température retournée: " + tempeRature.getValue());
	}
}