//Projet Eclipse RelaisEclairage
//
import com.pi4j.io.gpio.GpioController;
import com.pi4j.io.gpio.GpioFactory;
import com.pi4j.io.gpio.GpioPinDigitalInput;
import com.pi4j.io.gpio.GpioPinDigitalOutput;
import com.pi4j.io.gpio.PinPullResistance;
import com.pi4j.io.gpio.RaspiPin;
import com.pi4j.io.gpio.event.GpioPinDigitalStateChangeEvent;
import com.pi4j.io.gpio.event.GpioPinListenerDigital;

public class BoutonDistance {
	static boolean buttonPressed = false;

	public static void main(String[] args) throws InterruptedException {
		if (System.getProperty("os.name").startsWith("Windows")) {
  		System.out.println("Nous sommes sous Windows");
			return;
		}

		 System.out.println("Exemple: bouton et distance");
		 
     //GPIO controller
     final GpioController gpio = GpioFactory.getInstance();

     // Broche GPIO en entrée avec
    // " internal pull down resistor " activé
     final GpioPinDigitalInput myButton = gpio.provisionDigitalInputPin(RaspiPin.GPIO_25, PinPullResistance.PULL_DOWN);

     //Écouteur GPIO
     myButton.addListener(new GpioPinListenerDigital() {
         @Override
         public void handleGpioPinDigitalStateChangeEvent(GpioPinDigitalStateChangeEvent event) {
            //Montre le changement
            System.out.println("Changement d'état: " + event.getPin() + " = " + event.getState());
            
            if (buttonPressed == false) {
            	buttonPressed = true;
            }                 		
         }
     });

     GpioPinDigitalOutput sensorTriggerPin =  gpio.provisionDigitalOutputPin(RaspiPin.GPIO_28); // Trigger pin comme OUTPUT
     GpioPinDigitalInput sensorEchoPin = gpio.provisionDigitalInputPin(RaspiPin.GPIO_29,PinPullResistance.PULL_DOWN); // Echo pin comme INPUT
     
     //Boucle: Ctrl-C pour sortir
     for (;;) {
    	 if (buttonPressed) {
    		 System.out.println("Bouton pressé: prise de distance");  		 
    		 
    		 try {
      			sensorTriggerPin.high();        // Broche Trigger HIGH
            Thread.sleep((long) 0.01);      // Délai de 10 μs
            sensorTriggerPin.low();         // Broche Trigger LOW

            while(sensorEchoPin.isLow()){   // Attente Echo HIGH
            }
          
            long startTime = System.nanoTime(); // Début impulsion
            while(sensorEchoPin.isHigh()){      // Attente Echo LOW
            }
            long endTime = System.nanoTime();   // Fin impulsion
   			
      		  //Distance in cm (vitesse du son au niveau de la mer)  
      			System.out.println("Distance :" + (((endTime - startTime)/20000) * .34) + " cm"); 
      			
      			Thread.sleep(1000);
      			buttonPressed = false;
      		} 
      		catch (InterruptedException e) {
      			e.printStackTrace();
      		}
       }
         
    	 Thread.sleep(500);
     }
	}
}