//Projet Eclipse EmailEnvoi
//
import java.util.Properties;

import javax.mail.*;
import javax.mail.internet.*;
import javax.mail.Message.RecipientType;

public class EmailEnvoi {
	private String smtpHost;
	private String port;
	private String secure;
	private String user;
	private String passwd;
	
	EmailEnvoi(String host, String port, String secure, String user, String passwd) {
		this.smtpHost = host;
		this.port     = port;
		this.secure   = secure;
		this.user     = user;
		this.passwd   = passwd;
	}
	
	public void envoyer(String leSujet, String leContenu, String destinataire) {
		//Les paramètres du serveur de courriel sont stockés dans la classe Properties
		//
		Properties properties = System.getProperties();
			
		properties.setProperty("mail.smtp.host", smtpHost);
		properties.setProperty("mail.smtp.port", port); 
		properties.setProperty("mail.smtp.auth", "true"); 
		properties.setProperty("mail.smtp." + secure + ".enable", "true");

		//Un objet de Session nécessaire pour la transaction
		Session session = Session.getDefaultInstance(properties);

		try {
			//MimeMessage: le courriel lui-même
			MimeMessage message = new MimeMessage(session);

			//Celui qui envoie le message
			message.setFrom(new InternetAddress(user));

			//Le destinataire du message
			message.addRecipient(RecipientType.TO, new InternetAddress(destinataire));

			//Le sujet du message
			message.setSubject(leSujet);

			//Le corps du message
			message.setText(leContenu);
			message.saveChanges();

			//Envoi du message
			//
			Transport tr = session.getTransport("smtp");
			tr.connect(smtpHost, user, passwd);
	         
			//Avant message.saveChanges();
			tr.sendMessage(message, message.getAllRecipients());
			tr.close();
			System.out.println("Message envoyé avec succès....");
		} 
		catch (MessagingException mE) {
			mE.printStackTrace();
		}
	}

	public static void main(String[] args) {
		EmailEnvoi eEnv1 = new EmailEnvoi("ssl0.ovh.net", "465", "ssl", "address_email", "mot_de_passe");
		//EmailEnvoi eEnv2 = new EmailEnvoi("smtp.gmail.com", "587", "starttls", "address_email", "mot_de_passe");
		//EmailEnvoi eEnv3 = new EmailEnvoi("smtp.mail.yahoo.fr", "465", "ssl", "address_email", "mot_de_passe");
		
		eEnv1.envoyer("Notre sujet (OVH SMTP)", "Le nouveau contenu du message", "address_email");
		//eEnv2.envoyer("Un autre sujet (Gmail SMTP)", "Un autre contenu de message", "address_email");
		//eEnv3.envoyer("Un autre sujet encore (Yahoo SMTP)", "Un autre contenu encore de message", "address_email");	
	}
}