//Projet Eclipse EmailEnvoi
//
import java.io.File;
import java.io.IOException;
import java.util.Properties;

import javax.mail.*;
import javax.mail.internet.*;
import javax.mail.Message.RecipientType;

import javax.activation.DataHandler;
import javax.activation.DataSource;
import javax.activation.FileDataSource;

public class EmailImage {
	private String  smtpHost;
	private String  port;
	private String  secure;
	private String  user;
	private String  passwd;
	private boolean withPrint; 
	
	EmailImage(String host, String port, String secure, String user, String passwd, boolean withPrint) {
		this.smtpHost  = host;
		this.port      = port;
		this.secure    = secure;
		this.user      = user;
		this.passwd    = passwd;
		this.withPrint = withPrint;
	}
	
	public void sendImg(String leSujet, String imgDirName, String imgFileName, String content, String destinataire) {
		//Les paramètres du serveur Email sont stockés dans la classe Properties
		//
		Properties properties = System.getProperties();
			
		properties.setProperty("mail.smtp.host", smtpHost);
		properties.setProperty("mail.smtp.port", port); 
		properties.setProperty("mail.smtp.auth", "true"); 
		properties.setProperty("mail.smtp." + secure + ".enable", "true");

		//Un objet de Session nécessaire pour la transaction
		Session session = Session.getDefaultInstance(properties);

		try {
			//MimeMessage: le courriel lui-même
			MimeMessage message = new MimeMessage(session);

			//L'expéditeur du message
			message.setFrom(new InternetAddress(user));

			//The destinataire du message
			message.addRecipient(RecipientType.TO, new InternetAddress(destinataire));

			//Le sujet du message
			message.setSubject(leSujet);
			
			//Le message lui-même: un texte et une pièce jointe
      Multipart multipart = new MimeMultipart();
      
      MimeBodyPart messageBodyPart = new MimeBodyPart();  //Texte
      
      multipart.addBodyPart(messageBodyPart);

      //Info sur le fichier
      String attachmentPath = imgDirName;
      String attachmentName = imgFileName;

      //Pièce jointe
      MimeBodyPart attachmentPart = new MimeBodyPart();
      
      File att = new File(new File(attachmentPath), attachmentName);
      try {
      	attachmentPart.attachFile(att);
			} 
      catch (IOException e) {
      	return;
			}

      messageBodyPart.setText(content);
      //Doit être UTF-8 pour les accents
      messageBodyPart.setContent(content, "text/html; charset=UTF-8");
      
      DataSource source = new FileDataSource(att);
      attachmentPart.setDataHandler(new DataHandler(source));
      attachmentPart.setFileName(attachmentName);
      multipart.addBodyPart(attachmentPart);
      message.setContent(multipart);
			
			//Envoi du message
			//
			Transport tr = session.getTransport("smtp");
			tr.connect(smtpHost, user, passwd);
	         
			tr.sendMessage(message, message.getAllRecipients());
			tr.close();
			if (withPrint) {
				System.out.println("Message envoyé avec succès....");
			}
		} 
		catch (MessagingException mE) {
			mE.printStackTrace();
		}
	}

	public static void main(String[] args) {
		EmailImage eEnv1 = new EmailImage("ssl0.ovh.net", "465", "ssl", "address_email", "mot_de_passe", true);
		
		String pathName = "/home/pi/camera";  //Emplacement de SQLite 
		String fileName = "test.jpg";
		
		//Test sous Windows
		if (System.getProperty("os.name").startsWith("Windows")) {
			pathName = "D:\\\\....";  //Répertoire
			fileName = "....";        //Fichier
		}
		
    String content = "Texte du message: " + pathName + " " + fileName;
    
		eEnv1.sendImg("Image", pathName, fileName, content, "address_email");
	}
}
