//Projet Eclipse EmailEnvoi
//
import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.text.SimpleDateFormat;
import java.util.Calendar;

public class EmailSqlite {
	public static void main(String[] args) {
		final Calendar cal = Calendar.getInstance();
    cal.add(Calendar.DATE, -1); //La date d'hier
    
    SimpleDateFormat dateFormat = new SimpleDateFormat("yyyy/MM/dd HH:mm:ss");
		String dateEtHeureStr = dateFormat.format(cal.getTime());
		
		String strDate = dateEtHeureStr.substring(0, 10);		
		System.out.println("La date d'hier: " + strDate);
		
		String mailMsg = null;  //Le contenu du courriel
		mailMsg = "Événements d'hier: " + strDate + "\n\n";
				
		Connection conn = null;
		try {
    	//Notre base de données avec la table Events
    	//
    	String url = "jdbc:sqlite:sqlitePi.db";
    	conn = DriverManager.getConnection(url);
      
    	Statement stmt = conn.createStatement();
      
    	String sql = "DELETE FROM Events";
    	stmt.executeUpdate(sql);
      
    	sql = "INSERT INTO Events VALUES " +
    				"('Temperature1','" + strDate + "','13:19:00',22.5)";
    	stmt.executeUpdate(sql);
    	sql = "INSERT INTO Events VALUES " +
    				"('Temperature1','" + strDate + "','14:19:00',22.6)";
    	stmt.executeUpdate(sql);
      
    	System.out.println("Deux enregistrements insérés dans sqlitePi.db");
    	
    	sql = "SELECT Nom, Heure, Valeur FROM Events " + "WHERE Date = '" + strDate + "';";
      
      stmt = conn.createStatement();
      ResultSet rs = stmt.executeQuery(sql);

      //Extraction des données
      //
      while(rs.next()){
      	//Extrait de chaque colonne
      	String nom = rs.getString("Nom");
      	String heure = rs.getString("Heure");
        float valeur = rs.getFloat("Valeur");
        
        //Ajoute l'entrée dans le contenu du message
        //
        mailMsg += nom + " " + heure + " " + valeur + "\n";
      }
      rs.close();
    } 
		catch (SQLException e) {
				System.out.println("Erreur1: " + e.getMessage());
				return;
    } 
    finally {
    	try {
    		if (conn != null) {
    			conn.close();
    		}
    	} 
      catch (SQLException ex) {
      	System.out.println("Erreur2: " + ex.getMessage());
      	return;
      }
    }	
		
		EmailEnvoi eEnv = new EmailEnvoi("ssl0.ovh.net", "465", "ssl", "address_email", "mot_de_passe");
		eEnv.envoyer("Données sqlitePi.db d'hier", mailMsg, "address_email");
	}
}
