//Projet Eclipse EmailEnvoi
//
import com.pi4j.io.gpio.RaspiPin;

public class PirEnvoiEmail {

	public static void main(String[] args) throws InterruptedException {
		System.out.println("PirEnvoiEmail a démarré");
    
		if (System.getProperty("os.name").startsWith("Windows")) {
			System.out.println("Pas pour Windows");
			return;
		}
        
		GetPirMovement getPirMvt = new GetPirMovement(true, RaspiPin.GPIO_06, true);
        
		getPirMvt.activatePirMvt();  //Activation du capteur de mouvement
        
		for (;;) {
			Thread.sleep(200);
            
			if (getPirMvt.getResetHadMouvement()) {
				getPirMvt.shutdown();  //Libère la ressource PIR
				
		    System.out.println("Mouvement détecté; photo");

				boolean isPicture = true;
				ProcessBuilderCamera pBP = new ProcessBuilderCamera(isPicture, false); 
				
				String[] cameraParam = {  //Spécification de l'image
						"-w", "656", "-h", "493", "-v", "-o"
				};
				
				String imgName = "pirtest.jpg";

				if (pBP.execShooting(cameraParam, imgName)) {  //Si photo prise
					EmailImage eEnv1 = new EmailImage("ssl0.ovh.net", "465", "ssl", "address_email", "mot_de_passe", true);
					
					String pathName = "/home/pi/java/sendmails";  //Emplacement de l'image 	
			    String content = "Mouvement détecté !";
			    
					eEnv1.sendImg("Alerte mouvement à la maison!", pathName, imgName, content, "address_email");
					System.out.println("Courriel envoyé avec photo de la caméra");
					
					break;  //Sortie de la boucle infinie for (;;)
				}
				else {
					System.out.println("Erreur dans la prise de la photo");
				}				
			}
		}
		
		System.out.println("PirEnvoiEmail est terminé");
	}
}